import System; 

var multiMatch:String = "This is a hello world sample.";
var subMatch:String = "     There has to be something to match.  Words should be enough.";

DoMultiMatch();
DoSubMatches();

function DoMultiMatch(){
    var re = /\w+/g; // Match words
    
    Console.WriteLine("Performing a match multiple times");
    while(re.test(multiMatch)) {
        Console.WriteLine(RegExp.index + "-" + RegExp.lastIndex + "\t" + RegExp.lastMatch);
    }
    Console.WriteLine();
    Console.WriteLine();
}

function DoSubMatches() {
    var re = /(\w+) (\w+) (\w+) (\w+)/i;
    
    Console.WriteLine("Performing a match with sub pattern matches");
    re.test(subMatch);
    
    Console.WriteLine("Matched Sub Pattern #1: " + RegExp.$1);
    Console.WriteLine("Matched Sub Pattern #2: " + RegExp.$2);
    Console.WriteLine("Matched Sub Pattern #3: " + RegExp.$3);
    Console.WriteLine("Matched Sub Pattern #4: " + RegExp.$4);
    Console.WriteLine("Matched Sub Pattern #5: " + RegExp.$5);
    Console.WriteLine("Matched Sub Pattern #6: " + RegExp.$6);
    Console.WriteLine("Matched Sub Pattern #7: " + RegExp.$7);
    Console.WriteLine("Matched Sub Pattern #8: " + RegExp.$8);
    Console.WriteLine("Matched Sub Pattern #8: " + RegExp.$9);
    Console.WriteLine("Last Matched Pattern  : " + RegExp.lastParen);
    
    Console.WriteLine();
    Console.WriteLine("Match Location: " + RegExp.index + "-" + RegExp.lastIndex);
    Console.WriteLine("Last Match:             begin-->" + RegExp.lastMatch + "<-- end");
    Console.WriteLine("Unmatched Left String:  begin-->" + RegExp.leftContext + "<-- end");
    Console.WriteLine("Unmatched Right String: begin-->" + RegExp.rightContext + "<-- end");

    Console.WriteLine();
    Console.WriteLine();
}
