import System;
import System.IO;
import System.Net;

public class SaveHtmlPage {
    public static function Main(Args:String[]) : void {
        if ( Args.Length < 3 ) {
            return;
        }
        
        // Perform the Web Request
        var wr:WebRequest = WebRequest.Create(Args[1]);
        var wrs:WebResponse = wr.GetResponse();
        
        if ( !(wrs instanceof HttpWebResponse) || HttpWebResponse(wrs).StatusCode == 200 ) {
            // Open the output File and get Network Stream
            var file:Byte[] = new Byte[wrs.ContentLength];
            var fs:FileStream = new FileStream(Args[2], FileMode.Create);
            var s:Stream = wrs.GetResponseStream();

            s.Read(file, 0, int(wrs.ContentLength));
            s.Close()

            fs.Write(file, 0, int(wrs.ContentLength));
            fs.Flush();
            fs.Close();
        }
        
        wrs.Close();
    }
}

SaveHtmlPage.Main(Environment.GetCommandLineArgs());