import System;
import System.IO;
import System.Net;
import System.Threading;

public class SaveHtmlPage {
    private static var pendingResult:Boolean = false;

    public static function Main(Args:String[]) : void {
        if ( Args.Length < 2 ) {
            return;
        }
        
        // Perform the Web Request
        var wr:WebRequest = WebRequest.Create(Args[1]);
        
        pendingResult = true;
        wr.BeginGetResponse(SaveHtmlPage.Download_Callback, wr);
        
        while(pendingResult) {
            Console.WriteLine("Counting once every second");
            System.Threading.Thread.Sleep(1000);
        }
        
        return;            
    }
    
    private static function Download_Callback(ar:IAsyncResult) : void {
        try {
            var wrs:WebResponse = WebRequest(ar.AsyncState).EndGetResponse(ar);
            wrs.Close();
        } catch(exc:Exception) {
            Console.WriteLine("Unable to obtain a valid response.");
        }
        pendingResult = false;
    }
}

SaveHtmlPage.Main(Environment.GetCommandLineArgs());