import System;

interface A {
    function MethodA() : void;
    function get PropertyA() : int;
    function set PropertyA(i:int);
}
interface B implements A {
    function MethodB() : void;
    function get PropertyB() : int;
    function set PropertyB(i:int);
}
interface C {
    function MethodA() : void;
    function MethodB() : void;
    function get PropertyA() : int;
    function set PropertyB(i:int);
}

class ExplicitInterface implements B, C {
    public function MethodA() : void {
    }
    public function get PropertyA() : int {
        return 1;
    }
    public function set PropertyA(i:int) {
    }

    public function MethodB() : void {
    }
    public function get PropertyB() : int {
        return 1;
    }
    public function set PropertyB(i:int) {
    }

    public function C.MethodA() : void {
    }
    public function C.MethodB() : void {
    }
    public function get C.PropertyA() : int {
        return 2;
    }
    public function set C.PropertyB(i:int) {
    }
}

var o:ExplicitInterface = new ExplicitInterface();
var a:A = o; 
var b:B = o;
var c:C = o;

Console.WriteLine(o.PropertyB);
Console.WriteLine(o.PropertyA);

Console.WriteLine(a.PropertyA); // Doesn't have a PropertyB

Console.WriteLine(c.PropertyA); // Doesn't have a PropertyB

Console.WriteLine(b.PropertyB);
Console.WriteLine(b.PropertyA);
