import System;
import System.Xml;

// Load the XML document
var xRed:XmlTextReader = new XmlTextReader("11-1.xml");
var bInternal = false;
var bLine = false;
var bLineDone = false;

// Get the root element
while(xRed.Read()) {
    if ( xRed.NodeType == XmlNodeType.Element ) {
        if ( xRed.LocalName == "INTERNAL" ) {
            if ( !bInternal ) {
                bInternal = true;
                Console.WriteLine("Internal Settings - ");
            }

            Console.WriteLine("\tName   : " + xRed.GetAttribute("Type"));
            Console.WriteLine("\tValue  : " + xRed.ReadString());
            Console.WriteLine();
        }
        
        if ( xRed.LocalName == "LINE" ) {
            if ( !bLine ) {
                bLine = true;
                Console.WriteLine("Line Objects - ");
            }
            
            bLineDone = false;
            while(xRed.Read() && !bLineDone) {
                if ( xRed.LocalName == "LABEL" ) {
                    Console.WriteLine("\tLabel  : " + xRed.ReadString());
                }
                if ( xRed.LocalName == "TYPE" ) {
                    Console.WriteLine("\tType   : " + xRed.ReadString());
                    Console.WriteLine();
                    bLineDone = true;
                }
            }
        }
    }
}
