import System;
import System.Drawing;
import System.Windows.Forms;

public class BasicForm extends Form {
    private var mainMenu:System.Windows.Forms.MainMenu;
    private var mnuFile:System.Windows.Forms.MenuItem;
    private var mnuOpen:System.Windows.Forms.MenuItem;
    private var mnuSave:System.Windows.Forms.MenuItem;
    private var mnuExit:System.Windows.Forms.MenuItem;

    public function BasicForm() {
        InitializeComponents();
    }
    
    private function Form_Open(sender:Object, e:EventArgs) : void {
    }
    
    private function Form_Save(sender:Object, e:EventArgs) : void {
    }

    private function Form_Exit(sender:Object, e:EventArgs) : void {
        this.Close();
    }

    private function InitializeComponents() : void {
        this.Text = "Basic Windows Forms";
        this.Height = 160;
        this.Width = 300;
        this.WindowState = FormWindowState.Normal;
        this.StartPosition = FormStartPosition.CenterScreen;

        this.mainMenu = new MainMenu();
        
        this.mnuFile = new MenuItem("&File");
        this.mnuOpen = new MenuItem("&Open", this.Form_Open, Shortcut.CtrlO);
        this.mnuSave = new MenuItem("&Save", this.Form_Save, Shortcut.CtrlS);
        this.mnuExit = new MenuItem("E&xit", this.Form_Exit, Shortcut.CtrlX);
        
        this.mainMenu.MenuItems.Add(this.mnuFile);
        this.mnuFile.MenuItems.AddRange(MenuItem[]([this.mnuOpen, this.mnuSave, new MenuItem("-"), this.mnuExit]));
        this.Menu = this.mainMenu;
    }
    
    public STAThreadAttribute() static function Main(Args:String[]) : void {
        Application.Run(new BasicForm());
    }
}

BasicForm.Main(Environment.GetCommandLineArgs());