// Title:   Listing 3-9
// Author:  Justin Rogers
//
//
import System;

// We need an array of Integers
var i:Int32 = 0;
var IntArray:Int32[] = new Int32[6];
var StringArray:String[] = new String[6];
var ObjectArray:Object[] = new Object[6];

IntArray[0] = 1;
IntArray[1] = -1;
IntArray[2] = 2;
IntArray[3] = -2;
IntArray[4] = 100000;
IntArray[5] = -100000;

// Lets join some Strings together
for(i = 0; i < 6; i++){
    // Lets cast to a string
    StringArray[i] = String(IntArray[i]);
    
    // And an Object
    ObjectArray[i] = Object(IntArray[i]);
}
Console.WriteLine(String.Join("|sep|", StringArray));
Console.WriteLine();

// Lets compare some strings together
for(i = 0; i < 6; i++,i++){
    // Print out the results of string comparisons
    Console.WriteLine(String.Compare(StringArray[i], StringArray[i+1]));
    Console.WriteLine(String.Compare(StringArray[i], StringArray[i]));
}
Console.WriteLine();

// Lets finish up with the formatting
var FormatString:String =
  "Hex the number\n{0:X}\n" +
  "Left align 20 characters\n{4,-20}\n" +
  "Right align 20 characters\n{5,20}\n";

Console.WriteLine(String.Format(FormatString, ObjectArray));
Console.WriteLine();
