import System;

var CommandLine:String[] = Environment.GetCommandLineArgs();
if ( CommandLine.Length < 3 ) {
    Console.WriteLine("Usage: 4-4.exe {operator1} {operand1} [{operand2}]");
}

var operator1:String = CommandLine[1];
var operand1:double = 0;
var operand2:double = 0;

// Only 1 argument is needed for some functions
operand1 = int(CommandLine[2]);
if ( operator1 == "+" || operator1 == "-" || operator1 == "*" ||
     operator1 == "/" || operator1 == "%" ){
    operand2 = int(CommandLine[3]);
}

var result1:double = 0;


switch(operator1) {
    case "+":
        result1 = operand1 + operand2;
        break;
    case "-":
        result1 = operand1 - operand2;
        break;
    case "*":
        result1 = operand1 * operand2;
        break;
    case "/":
        result1 = operand1 / operand2;
        break;
    case "%":
        result1 = operand1 % operand2;
        break;
    case "sqrt":
        result1 = Math.sqrt(operand1);
        break;
    case "log":
        result1 = Math.log(operand1);
        break;
    case "sin":
        result1 = Math.sin((Math.PI/180) * operand1); // Accept degrees
        break;
    case "cos":
        result1 = Math.cos((Math.PI/180) * operand1); // Accept degrees
        break;
    case "tan":
        result1 = Math.tan((Math.PI/180) * operand1); // Accept degrees
        break;
    case "asin":
        result1 = (180/Math.PI) * Math.asin(operand1); // Output degrees
        break;
    case "acos":
        result1 = (180/Math.PI) * Math.acos(operand1); // Output degrees
        break;
    case "atan":
        result1 = (180/Math.PI) * Math.atan(operand1); // Output degrees
        break;
}

// We have to print in two different formats
if ( operator1 == "+" || operator1 == "-" || operator1 == "*" ||
     operator1 == "/" || operator1 == "%" ){
    Console.WriteLine("The result of " + operand1 + " " +
        operator1 + " " + operand2 + " is " + result1);
} else {
    Console.WriteLine("The result of " + operator1 + " " +
        operand1 + " is " + result1);
}

