import System;

interface A {
    function MethodA() : void;
    function get PropertyA() : int;
    function set PropertyA(i:int);
}
interface B implements A {
    function MethodB() : void;
    function get PropertyB() : int;
    function set PropertyB(i:int);
}
interface C {
    function MethodA() : void;
    function MethodB() : void;
    function get PropertyA() : int;
    function set PropertyB(i:int);
}

class InheritedInterface implements B, C {
    public function MethodA() : void {
    }
    public function get PropertyA() : int {
        return 1;
    }
    public function set PropertyA(i:int) {
    }

    public function MethodB() : void {
    }
    public function get PropertyB() : int {
        return 1;
    }
    public function set PropertyB(i:int) {
    }
}

var o:InheritedInterface = new InheritedInterface();
var b:B = o; // get interface instances
var c:C = o;

Console.WriteLine(o.PropertyB);
Console.WriteLine(o.PropertyA);

Console.WriteLine(c.PropertyA); // Doesn't have a PropertyB

Console.WriteLine(b.PropertyB);
Console.WriteLine(b.PropertyA);
